<?php

/*------------------------------------------------------------------------
# com_invoices - Invoice Manager for Joomla
# ------------------------------------------------------------------------
# author				Germinal Camps
# copyright 			Copyright (C) 2012 - 2016 JoomlaThat.com. All Rights Reserved.
# @license				http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: 			http://www.joomlathat.com
# Technical Support:	Forum - http://www.joomlathat.com/support
-------------------------------------------------------------------------*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

//new for Joomla 3.0
if(!defined('DS')){
define('DS',DIRECTORY_SEPARATOR);
}

class  plgHikashopInvoicemanager extends JPlugin
{

	var $lang_tag = "en-GB";

	function __construct(& $subject, $config)
	{
		$lang = JFactory::getLanguage();
		$lang->load('com_invoices', JPATH_SITE);

		$this->lang_tag = $lang->getTag();

		parent::__construct($subject, $config);

	}

	function onAfterOrderCreate(&$order,&$send_email) {
		$this->create_invoice($order);
	}

	function onAfterOrderUpdate(&$order,&$send_email) {
		$this->create_invoice($order);
	}

	function create_invoice($order) {

		require_once(JPATH_SITE.DS.'components'.DS.'com_invoices'.DS.'helpers'.DS.'helpers.php');

		$component = "com_hikashop" ;

		//only attempt to create the invoice if the order status is CONFIRMED
		if($order->order_status == $this->params->get('status', "confirmed") || $this->params->get('status') == "all"){

			$db = JFactory::getDBO();

			$is_new = false;
			$must_update = false ;
			$invoice_id = 0 ;

			//we check if this particular order had already been tracked
			$query = " SELECT id FROM #__invoices_invoices WHERE external_type = '".$component."' AND external_id = ".$order->order_id;
			$db->setQuery($query);
			$exists = $db->loadResult();

			if(!$exists){
				$is_new = true ;
			}
			else{
				$must_update = true ;
				$invoice_id = $exists;
			}

			if($is_new || $must_update){

				$params = JComponentHelper::getParams( 'com_invoices' );

				$query = ' SELECT i.real_invoice_num FROM #__invoices_invoices as i WHERE i.type = 1 '.
						 ' ORDER BY i.id DESC ';
				$db->setQuery( $query );
				$real_invoice_num = $db->loadResult() + 1;
				$invoice_num = InvoicesHelper::getInvoiceNum($real_invoice_num) ;

				if(isset($order->order_billing_address_id) && !empty($order->order_billing_address_id)) $order_billing_address_id = $order->order_billing_address_id ;
				else $order_billing_address_id = $order->old->order_billing_address_id ;

				$query = " SELECT * FROM #__hikashop_address WHERE address_id = ".(int)$order_billing_address_id;
				$db->setQuery($query);
				$address = $db->loadObject();

				if(isset($order->order_user_id) && !empty($order->order_user_id)) $order_user_id = $order->order_user_id ;
				else $order_user_id = $order->old->order_user_id ;

				$query = " SELECT * FROM #__hikashop_user WHERE user_id = ".(int)$order_user_id;
				$db->setQuery($query);
				$user = $db->loadObject();

				//country
				$country = str_replace("country_", "", $address->address_country) ;
				$country_id = substr($country, strrpos($country, "_") + 1) ;
				$query = " SELECT * FROM #__hikashop_zone WHERE zone_id = ".(int)$country_id;
				$db->setQuery($query);
				$country = $db->loadObject();
				//state
				$state = str_replace("state_", "", $address->address_state) ;
				$state_id = substr($state, strrpos($state, "_") + 1) ;
				$query = " SELECT * FROM #__hikashop_zone WHERE zone_id = ".(int)$state_id;
				$db->setQuery($query);
				$state = $db->loadObject();

				if(isset($order->order_number) && !empty($order->order_number)) $order_number = $order->order_number ;
				else $order_number = $order->old->order_number ;

				if(isset($order->order_discount_price) && !empty($order->order_discount_price)) $order_discount_price = $order->order_discount_price ;
				else $order_discount_price = $order->old->order_discount_price ;

				$taxes = array();

				$invoice_date = date('Y-m-d H:i:s');

				$app = JFactory::getApplication();
				if($app->isSite()) $language = $this->lang_tag;
				else $language = $params->get('default_language', 'en-GB');

				$link_contact = 2;
				$contact_id = 0;

				$query = " SELECT id FROM #__invoices_contacts WHERE email = ".$db->q($user->user_email);
				$db->setQuery($query);
				$contact_id = (int)$db->loadResult();

				if($contact_id) $link_contact = 1;

				if(!$is_new){ // we are updating. These fields should NOT be updated.
					$real_invoice_num = null;
					$invoice_num = null;
					$invoice_date = null;
					$language = null;
					$link_contact = 1;
					$contact_id = null;
				}

				$invoice_data = array(
								"id" => $invoice_id ,
								"to_name" => $address->address_firstname . " " . $address->address_middle_name . " " .$address->address_lastname ,
								"to_company" => $address->address_company,
								"to_address" => $address->address_street . "\n" . $address->address_street2,
								"to_email" => $user->user_email,
								"to_zipcode" => $address->address_post_code,
								"to_city" => $address->address_city,
								"to_state" => $state->zone_name_english,
								"to_country" => $country->zone_name_english,
								"to_phone" => $address->address_telephone,
								"to_vatid" => $address->address_vat,
								"vincular_cliente_checkbox" => $link_contact,
								"user_id" => $contact_id,
								"from_name" => $params->get('from_name'),
								"from_address" => $params->get('from_address'),
								"from_num" => $params->get('from_num'),
								"from_url" => $params->get('from_url'),
								"from_email" => $params->get('from_email'),
								"from_phone" => $params->get('from_phone'),
								"invoice_num" => $invoice_num,
								"real_invoice_num" => $real_invoice_num,
								"invoice_date" => $invoice_date,
								"template_id" => $params->get('invoice_template'),
								"currency_id" => $params->get('currency_id'),
								"language" => $language,
								"publish" => $this->params->get('activation'),
								"start_publish" => null,
								"end_publish" => null,
								"joomla_user_id" => $user->user_cms_id,
								"taxes" => $taxes,
								"status" => null,
								"external_type" => $component,
								"external_id" => $order->order_id,
								"external_ref" => $order_number,
								"discount" => $order_discount_price,
								"sendemail" => $this->params->get('sendemail', 0)
								) ;

			$query = " SELECT hop.*, hp.product_description
									FROM #__hikashop_order_product AS hop
									LEFT JOIN #__hikashop_product AS hp ON hp.product_id = hop.product_id
									WHERE order_id = ".$order->order_id;
			$db->setQuery($query);
			$products = $db->loadObjectList();

			$items = array();

			foreach($products as $product){

				$product_exists = 0 ;

				if($must_update){
					$query = " SELECT id FROM #__invoices_items WHERE invoice_id = '".$invoice_id."' AND external_type = '".$component."' AND product_id = ".$product->product_id;
					$db->setQuery($query);
					$product_exists = $db->loadResult();
				}

				$product_id = $product_exists ;

				if($product->order_product_price > 0) $thetax = round(( $product->order_product_tax / $product->order_product_price ) * 100, $this->params->get('roundtax', 2)) ;
				else $thetax = 0 ;

				$items[] = array(
									"id" => $product_id,
									"sku" => $product->order_product_code,
									"name" => strip_tags($product->order_product_name),
									"desc" => strip_tags($product->product_description),
									"value" => $product->order_product_price,
									"amount" => $product->order_product_quantity,
									"tax" => $thetax ,
									"tax_id" => $this->params->get('tax_id', 0),
									"external_type" => $component,
									"product_id" => $product->product_id,
									);

			}

			if(isset($order->order_number) && !empty($order->order_number)) $theorder = $order;
			else $theorder = $order->old;

			//Shipping
			if($theorder->order_shipping_price > 0){

				$shipping_name = "";

				if($theorder->order_shipping_id){

					$query = " SELECT * FROM #__hikashop_shipping WHERE shipping_id = ".$theorder->order_shipping_id;
					$db->setQuery($query);
					$shipping = $db->loadObject();

					$shipping_name = $shipping->shipping_name ;

				}

				$shipping_price = $theorder->order_shipping_price - $theorder->order_shipping_tax ;

				$shipping_item_exists = 0 ;

				if($must_update){
					$query = " SELECT id FROM #__invoices_items WHERE invoice_id = '".$invoice_id."' AND external_type = '".$component."_shipping' ";
					$db->setQuery($query);
					$shipping_item_exists = $db->loadResult();
				}

				$shipping_item_id = $shipping_item_exists ;

				$items[] = array(
									"id" => $shipping_item_id,
									"sku" => "",
									"name" => JText::_("Shipping"),
									"desc" => $shipping_name,
									"value" => $shipping_price,
									"amount" => 1,
									"tax" => ( $theorder->order_shipping_tax / $shipping_price ) * 100,
									"tax_id" => $this->params->get('tax_id', 0),
									"external_type" => $component."_shipping",
									"product_id" => 0,
									);
			}

			//Payment
			if($order->order_payment_price > 0){

				$payment_name = "";

				if($order->order_payment_id){

					$query = " SELECT * FROM #__hikashop_payment WHERE payment_id = ".$order->order_payment_id;
					$db->setQuery($query);
					$payment = $db->loadObject();

					$payment_name = $payment->payment_name ;

				}

				$payment_item_exists = 0 ;

				if($must_update){
					$query = " SELECT id FROM #__invoices_items WHERE invoice_id = '".$invoice_id."' AND external_type = '".$component."_payment' ";
					$db->setQuery($query);
					$payment_item_exists = $db->loadResult();
				}

				$payment_item_id = $payment_item_exists ;

				$items[] = array(
									"id" => $payment_item_id,
									"sku" => "",
									"name" => JText::_("Payment"),
									"desc" => $payment_name,
									"value" => $order->order_payment_price,
									"amount" => 1,
									"tax" => 0,
									"tax_id" => $this->params->get('tax_id', 0),
									"external_type" => $component."_payment",
									"product_id" => 0,
									);
			}

			$payments = array();

			if($order->order_status == "confirmed") $payment_status = 1 ;
			else $payment_status = 0 ;

			$payment_exists = 0 ;

			if(!$order->order_full_price) $order = $order->old;

			if($must_update){
				$query = " SELECT id FROM #__invoices_payments WHERE invoice_id = '".$invoice_id."' AND payment_type = 'payment_".$order->order_payment_method . "' ";
				$db->setQuery($query);
				$payment_exists = $db->loadResult();
			}

			$payment_id = $payment_exists ;

			$payments[0] = array(
								"id" => $payment_id,
								"payment_details" => $order->order_payment_params,
								"payment_datetime" => date('Y-m-d H:i:s'),
								"payment_amount" => $order->order_full_price,
								"payment_type" => "payment_".$order->order_payment_method,
								"payment_description" => "Payment",
								"payment_id" => $order->order_payment_id,
								"payment_status" => $payment_status
								);

			InvoicesHelper::create_invoice($invoice_data, $items, $payments);
			}

		}
	}
}
